<script lang="ts">
	import '../../app.css';
	import FooterNav from '../../components/footer/FooterNav.svelte';
	import Header from '../../components/Header.svelte';
	import 'iconify-icon';
	import { onMount } from 'svelte';
	import { scrollY, showMenu, store_screenWidth } from '../../utils/store';
	import { auth, setAnalytics } from '../../lib/firebase/firebase';
	import { goto } from '$app/navigation';
	import { page } from '$app/stores';

	let y = 0;

	onMount(() => {
		const handleScroll = () => {
			y = window.scrollY;
		};

		if (typeof window !== 'undefined') {
			setAnalytics();
		}

		window.addEventListener('scroll', handleScroll);

		return () => {
			window.removeEventListener('scroll', handleScroll);
		};
	});

	let screenWidth: number = 0;
	$: if (y) {
		scrollY.update((_) => y);
	}

	$: if (screenWidth) {
		store_screenWidth.update((_) => screenWidth);
	}

	let headerHeight: number;

	const nonAuthRoutes = [
		'/',
		'/metrouver',
		'/fournisseurs',
		'/produit',
		'/admin',
		'/mentions-legales'
	];
	let asLoaded: boolean = false;
	onMount(() => {
		asLoaded = true;

		const unsubscribe = auth.onAuthStateChanged(async (user) => {
			const currentPath = window.location.pathname;
			if (!user && !nonAuthRoutes.includes(currentPath)) {
				window.location.href = '/';
				return;
			}

			// if (user && currentPath === '/') {
			// 	window.location.href = '/dashboard';
			// 	return;
			// }

			if (!user) {
				return;
			}
		});
		return unsubscribe;
	});

	$showMenu = false;
</script>

<svelte:window bind:innerWidth={screenWidth} />

<div class="relative flex flex-col" style={'width:' + screenWidth + 'px; '}>
	<Header bind:headerHeight />
	<div class="grow md:mb-0 mb-14">
		<slot />
		{#if $page.url.pathname !== '/mentions-legales'}
			<div class="w-full px-2 py-4 text-noir-500">
				<button
					class="bg-primary-500 w-full p-2 flex items-center justify-center rounded-xl"
					on:click={() => {
						goto('/mentions-legales');
					}}
				>
					<span class="font-semibold">Mentions légales</span>
				</button>
			</div>
		{/if}
		{#if screenWidth <= 768 && asLoaded}
			<FooterNav />
		{/if}
	</div>
</div>
